/**
Sisesta klavatuurilt vi genereeri smbolite maatriks.
Sorteeri iga jada maatriksiks ja siis sorteeri jadad omavahel.
Kik stringid saavad olla kuni SYMBOLSINWORD pikad, stringid lppevad WORDDELIMETER-ga.
Sna vib olla jagatud mitmesse stringi.
Viimane sne peab lppema ENDDELIMETER-ga.
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

//changeable constants
#define WORDS 8
#define SYMBOLSINWORD 7
#define WORDDELIMETER ' '
#define ENDDELIMETER '.'
const char INPUTCHOICESTRING[] = "0 - String from keyboard; 1 - Random input: \n";

///not changeable constants
#define WORDLENGTH SYMBOLSINWORD + 1

char randomLetter(int);
void checkStringCase(char[]);
char checkCase(char);
void randomWord(char[WORDLENGTH]);
void fillStringArray(char[][WORDLENGTH], int);
int inputStyle(const char[]);
void inputString(char[], char[][WORDLENGTH]);
void parseString(char[], char[][WORDLENGTH]); //string -> matrix
void printMatrix(char[][WORDLENGTH]); //print matrix
void printString(char[][WORDLENGTH]); //print matrix -> string
void removeGarbage(char[][WORDLENGTH]);//initialize matrix
void mainSorter(char[][WORDLENGTH]);
void bubbleSortCharArray(char[]);//sort 1 string
void bubbleSortCharMatrix(char[][WORDLENGTH]);//sort strings
void swap(char*, char*);

int main(void){
    srand(time(NULL));
    char charMatrix[WORDS][WORDLENGTH];
    fillStringArray(charMatrix, inputStyle(INPUTCHOICESTRING));
    printf("\nNot sorted:\n");
    printMatrix(charMatrix);
    mainSorter(charMatrix);
    printf("\nSorted:\n");
    printMatrix(charMatrix);
    return 0;
}

int inputStyle(const char s[]){
    int x, c;
    printf("%s", s);
    scanf("%d", &x);
    while((c = getchar()) != '\n' && c != EOF){}
    return x;
}

char randomLetter(int y){
    int extra = rand() % (y+1);
    return rand() % ('Z'-'A'+1) + 'A' - extra*2;
}

void randomWord(char string[]){
    int j;
    for(j=0;j<SYMBOLSINWORD;j++){
        string[j] = randomLetter(j);
        if(string[j] < 'A')
            break;
    }
    string[j] = '\0';
}

void removeGarbage(char matrix[][WORDLENGTH]){
    int i;
    for(i=0;i<WORDS;i++)
        matrix[i][0] = '\0';
}

char checkCase(char c){
    if(c >= 'a' && c <= 'z')
        return c - 'a' + 'A';
    return c;
}

void parseString(char longString[], char charMatrix[][WORDLENGTH]){
    int i, j, k = -1;
    removeGarbage(charMatrix);
    for(i=0;i<WORDS;i++){
        for(j=0;j<SYMBOLSINWORD;j++){
            charMatrix[i][j] = '\0';
            k++;
            if(longString[k] == ENDDELIMETER){
                i = WORDS;
                break;
            }
            if(longString[k] == WORDDELIMETER)
                break;
            charMatrix[i][j] = checkCase(longString[k]);
        }
        charMatrix[i][SYMBOLSINWORD] = '\0';
    }
}

void inputString(char s[], char charMatrix[][WORDLENGTH]){
    char input[WORDS*WORDLENGTH];
    printf("%s", s);
    fgets(input, sizeof(input), stdin);
    parseString(input, charMatrix);
}

void fillStringArray(char charMatrix[][WORDLENGTH], int choice){
    int i;
    if(choice){
        for(i=0;i<WORDS;i++)
            randomWord(charMatrix[i]);
		printString(charMatrix);
    }else
        inputString("Your string:\n", charMatrix);
}

void printString(char charMatrix[][WORDLENGTH]){
	int i;
	printf("Random string:");
	for(i=0;i<WORDS;i++){
		printf(" %s", charMatrix[i]);
	}
	printf(".\n");
}

void printMatrix(char charMatrix[][WORDLENGTH]){
    int i, j = 0;
    for(i=0;i<WORDS;i++)
        if(charMatrix[i][0] != '\0')
            printf("%2d. %s\n", ++j, charMatrix[i]);
}

void swap(char* a, char* b){
    char temp = *a;
    *a = *b;
    *b = temp;
}

void bubbleSortCharArray(char string[]){
    int i, j;
    for(i=0;i<strlen(string);i++)
        for(j=0;j<strlen(string)-i-1;j++)
            if(string[j]>string[j+1])
                swap(&string[j], &string[j+1]);
}

void bubbleSortCharMatrix(char charMatrix[][WORDLENGTH]){
    int i, j, k;
    for(i=0;i<WORDS;i++)
        for(j=0;j<WORDS-i-1;j++)
            if(strcmp(charMatrix[j], charMatrix[j+1])>0)
                for(k=0;k<WORDLENGTH;k++)
                    swap(&charMatrix[j][k], &charMatrix[j+1][k]);
}

void mainSorter(char matrix[][WORDLENGTH]){
    int i;
    for(i=0;i<WORDS;i++)
        bubbleSortCharArray(matrix[i]);
    printf("\nHalf Sorted:\n");
    printMatrix(matrix);
    bubbleSortCharMatrix(matrix);
}
